﻿/*
 * C'Gol
 * Project based on Conway's Game of Life
 * 
 * Made by:
 * Alexander Noss
 * Christian Rautenberg
 * David Zentner
 * Philipp Erler
 * Stephan Schneider
 * 
 * As IT project for summer-semester 2011 (Group IT2D)
 * 
 * ####################################################################
 * FileForm for loading and saving fields
 * Part of C'Gol GUI
 * ####################################################################
 * 
 * Last change:     2011 | 07 | 04
 * 
 * Mail me for feedback, version requests etc.: 	ph.erler@gmx.net
 * Look at http://www.hs-esslingen.de/~pherit00/website/index.htm
 * .Net - Framework 4.0 must be installed.
 * 
 */


using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CGol
{
    public partial class frmFiles : Form
    {
        //this form can be used for loading and saving files
        public enum LoadSaveState
	    {	        Load, Save	    }
        private LoadSaveState lSState = 0;
        
        //delegate to function for file operation
        public delegate void fileFunction(byte FileNum);
        fileFunction fileDeleg;

        //constructor
        public frmFiles()                                               
        {
            InitializeComponent();
        }

        //extra constuctor to set state of form
        public frmFiles(LoadSaveState state)                            
        {
            InitializeComponent();
            lSState = state;                                            //set state

            //if state is load
            //enable buttons only if files exist 
            if (lSState == LoadSaveState.Load)                          
            {                                                           
                if (!System.IO.File.Exists("0.txt"))
                    but0.Enabled = false;
                if (!System.IO.File.Exists("1.txt"))
                    but1.Enabled = false;
                if (!System.IO.File.Exists("2.txt"))
                    but2.Enabled = false;
                if (!System.IO.File.Exists("3.txt"))
                    but3.Enabled = false;
                if (!System.IO.File.Exists("4.txt"))
                    but4.Enabled = false;
                if (!System.IO.File.Exists("5.txt"))
                    but5.Enabled = false;
                if (!System.IO.File.Exists("6.txt"))
                    but6.Enabled = false;
                if (!System.IO.File.Exists("7.txt"))
                    but7.Enabled = false;

                this.Text = "Load from File";
            }

            //add last change date of files if existing
            for (int i = 0; i < 8; i++)
            {
                string fileName = i.ToString() + ".txt";

                if (System.IO.File.Exists(fileName))
                {
                    DateTime lastChange = System.IO.File.GetLastAccessTime(fileName);

                    switch (i)
                    {
                        case 0:
                            but0.Text = "Field 0 - Last change: " + lastChange.ToString();
                            break;
                        case 1:
                            but1.Text = "Field 1 - Last change: " + lastChange.ToString();
                            break;
                        case 2:
                            but2.Text = "Field 2 - Last change: " + lastChange.ToString();
                            break;
                        case 3:
                            but3.Text = "Field 3 - Last change: " + lastChange.ToString();
                            break;
                        case 4:
                            but4.Text = "Field 4 - Last change: " + lastChange.ToString();
                            break;
                        case 5:
                            but5.Text = "Field 5 - Last change: " + lastChange.ToString();
                            break;
                        case 6:
                            but6.Text = "Field 6 - Last change: " + lastChange.ToString();
                            break;
                        case 7:
                            but7.Text = "Field 7 - Last change: " + lastChange.ToString();
                            break;
                    }
                }
            }
        }

        public void setFileFunction(fileFunction fileFunc)              //set delegate
        {
            fileDeleg = fileFunc;
        }

        #region buttons
        private void but0_Click(object sender, EventArgs e)
        {
            fileDeleg(ASCIIEncoding.ASCII.GetBytes("0")[0]);
            this.Dispose();
        }

        private void but1_Click(object sender, EventArgs e)
        {
            fileDeleg(ASCIIEncoding.ASCII.GetBytes("1")[0]);
            this.Dispose();
        }

        private void but2_Click(object sender, EventArgs e)
        {
            fileDeleg(ASCIIEncoding.ASCII.GetBytes("2")[0]);
            this.Dispose();
        }

        private void but3_Click(object sender, EventArgs e)
        {
            fileDeleg(ASCIIEncoding.ASCII.GetBytes("3")[0]);
            this.Dispose();
        }

        private void but4_Click(object sender, EventArgs e)
        {
            fileDeleg(ASCIIEncoding.ASCII.GetBytes("4")[0]);
            this.Dispose();
        }

        private void but5_Click(object sender, EventArgs e)
        {
            fileDeleg(ASCIIEncoding.ASCII.GetBytes("5")[0]);
            this.Dispose();
        }

        private void but6_Click(object sender, EventArgs e)
        {
            fileDeleg(ASCIIEncoding.ASCII.GetBytes("6")[0]);
            this.Dispose();
        }

        private void but7_Click(object sender, EventArgs e)
        {
            fileDeleg(ASCIIEncoding.ASCII.GetBytes("7")[0]);
            this.Dispose();
        }
        #endregion

        //close form
        private void butCancel_Click(object sender, EventArgs e)        //close window
        {
            this.Dispose();
        }
    }
}
